#!/usr/bin/env python

# example helloworld.py

import pygtk
pygtk.require('2.0')
import gtk
#from gypsy import *
import dbus, math
import gtk, gobject, dbus, dbus.mainloop.glib
from compassWidget import *
from geoerrandapp import *
from utilSigFig import *

class GeoErrandGui:

    def delete_event(self, widget, event, data=None):
        # If you return FALSE in the "delete_event" signal handler,
        # GTK will emit the "destroy" signal. Returning TRUE means
        # you don't want the window to be destroyed.
        # This is useful for popping up 'are you sure you want to quit?'
        # type dialogs.
        print "delete event occurred"

        # Change FALSE to TRUE and the main window will not be destroyed
        # with a "delete_event".
        return False

    def destroy(self, widget, data=None):
        print "destroy signal occurred"
	self.loop.quit()
        #gtk.main_quit()

    def __init__(self):
	self.loop = gobject.MainLoop()

	self.app = GeoErrandApp()	
	self.app.guiRefreshFunc = self.GuiRefresh
	#self.app.LoadPositionData("missing.gpx")
	self.sortedErrands = []

        # create a new window
        self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
    
        # When the window is given the "delete_event" signal (this is given
        # by the window manager, usually by the "close" option, or on the
        # titlebar), we ask it to call the delete_event () function
        # as defined above. The data passed to the callback
        # function is NULL and is ignored in the callback function.
        self.window.connect("delete_event", self.delete_event)
    
        # Here we connect the "destroy" event to a signal handler.  
        # This event occurs when we call gtk_widget_destroy() on the window,
        # or if we return FALSE in the "delete_event" callback.
        self.window.connect("destroy", self.destroy)
    
        # Sets the border width of the window.
        self.window.set_border_width(10)
    
        # Creates a new button with the label "Hello World".
        self.button = gtk.Button("Quit")
    
        # This will cause the window to be destroyed by calling
        # gtk_widget_destroy(window) when "clicked".  Again, the destroy
        # signal could come from here, or the window manager.
        self.button.connect_object("clicked", gtk.Widget.destroy, self.window)
    
	self.status = gtk.Entry(0)
	self.status.set_text("Not set")
	self.status.set_editable(0)

	#self.CalcErrandDistances()
        self.treeView = gtk.TreeView(self.PopulateErrandTable())
        self.treeView.connect("cursor-changed", self.ErrandSelected)
        self.treeView.set_rules_hint(True)
	self.CreateErrandTableColumns(self.treeView)
	
	self.treeViewScroll = gtk.ScrolledWindow()
	self.treeViewScroll.add(self.treeView)
	self.treeViewScroll.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_AUTOMATIC)

	self.refreshButton = gtk.Button("Refresh")
	self.refreshButton.connect("clicked",self.RefreshErrandTable ,None)

	self.pageSelect = gtk.VBox()

	self.pageErrandButton = gtk.Button("Errands")
	self.pageFindButton = gtk.Button("Find")
	self.pageAnnotateButton = gtk.Button("Annotate")
	self.pageTransferButton = gtk.Button("Transfer")

	self.pageSelectButtons = gtk.HBox()
	self.pageSelectButtons.pack_start(self.pageErrandButton,True)
	self.pageSelectButtons.pack_start(self.pageFindButton,True)
	self.pageSelectButtons.pack_start(self.pageAnnotateButton,True)
	self.pageSelectButtons.pack_start(self.pageTransferButton,True)

	self.pageErrandButton.connect("clicked",self.ChangePage ,"Errand")
	self.pageFindButton.connect("clicked",self.ChangePage ,"Find")
	self.pageAnnotateButton.connect("clicked",self.ChangePage ,"Annotate")
	self.pageTransferButton.connect("clicked",self.ChangePage ,"Transfer")

	#**** Errand Page ****

	self.errandPage = gtk.VBox()
	self.errandPage.pack_start(self.status,False)
	self.errandPage.pack_start(self.refreshButton,False)
	self.errandPage.pack_start(self.treeViewScroll,True)
	self.errandPage.pack_start(self.button,False)

	#**** Find Page *****

	self.compass = CompassWidget()

	self.errandName = gtk.Entry(0)
	self.errandName.set_text("Not set")
	self.errandName.set_editable(0)

	self.guide = gtk.Entry(0)
	self.guide.set_text("Not set")
	self.guide.set_editable(0)

	self.findPage = gtk.VBox()
	self.findPage.pack_start(self.errandName,False)
	self.findPage.pack_start(self.guide,False)
	self.findPage.pack_start(self.compass,True)

	#**** Annotate Page ****

	self.annotatePage = gtk.VBox()

	self.annotateTextBuffer = gtk.TextBuffer()
	#self.annotateTextBuffer.set_text("Foo\nBar\n")
	
	self.annotateText = gtk.TextView(self.annotateTextBuffer)
	#self.annotateText.set_text("Not set")
	#self.annotateText.set_editable(0)

	self.annotateTextScroll = gtk.ScrolledWindow()
	self.annotateTextScroll.add(self.annotateText)
	self.annotateTextScroll.set_policy(gtk.POLICY_NEVER,gtk.POLICY_AUTOMATIC)

	self.setClearBar = gtk.HBox()
	
	self.annotateSetPosButton = gtk.Button("Set Pos")
	self.annotateSetPosButton.connect("clicked",self.AnnotateSetPos ,None)
	self.annotateClearPosButton = gtk.Button("Clear Pos")
	self.annotateClearPosButton.connect("clicked",self.AnnotateClearPos ,None)

	self.setClearBar.pack_start(self.annotateSetPosButton,True)
	self.setClearBar.pack_start(self.annotateClearPosButton,True)

	self.annotateStatus = gtk.Statusbar()

	self.annotatePage.pack_start(self.annotateTextScroll,True)
	self.annotatePage.pack_start(self.setClearBar,False)
	self.annotatePage.pack_start(self.annotateStatus,False)

	#**** Transfer Page ****

	self.transferPage = gtk.VBox()

	self.downloadErrandsButton = gtk.Button("Download Errands")	
	self.loadErrandsButton = gtk.Button("Get Errands from Local File")	
	self.uploadAnnotationsButton = gtk.Button("Upload Annotations")	
	self.clearAnnotationsButton = gtk.Button("Clear Annotations")

	self.transferPage.pack_start(self.downloadErrandsButton,True)
	self.transferPage.pack_start(self.loadErrandsButton,True)
	self.transferPage.pack_start(self.uploadAnnotationsButton,True)
	self.transferPage.pack_start(self.clearAnnotationsButton,True)

	self.downloadErrandsButton.connect("clicked",self.DownloadErrands ,None)
	self.loadErrandsButton.connect("clicked",self.LoadErrands ,None)
	self.uploadAnnotationsButton.connect("clicked",self.UploadToInternet ,None)
	self.clearAnnotationsButton.connect("clicked",self.ClearAnnotations ,None)

	#**** Page Selection ****
	
	self.pageSelect.pack_start(self.pageSelectButtons,False)
	self.pageSelect.pack_start(self.errandPage,True)
	self.pageSelect.pack_start(self.findPage,True)
	self.pageSelect.pack_start(self.annotatePage,True)
	self.pageSelect.pack_start(self.transferPage,True)

	self.window.add(self.pageSelect)
    
	self.window.show_all()
	self.findPage.hide()
	self.annotatePage.hide()
	self.transferPage.hide()

    def ErrandSelected(self, widget):
	#Save current annotations
	(start, end) = self.annotateTextBuffer.get_bounds()
	self.SaveTextAnnotation(self.annotateTextBuffer.get_text(start, end))
        
	selection = widget.get_selection().get_selected_rows()
	if len(selection[1][0]) is 0: return
	selectedRow = selection[1][0][0]
	#print selectedRow
        #model = widget.get_model()
	#print model[row]
        #text = model[row][0] + ", " + model[row][1]
        #self.statusbar.push(0, text)
	#print self.sortedErrands[selectedRow][1]
	self.app.SetTargetErrand(self.sortedErrands[selectedRow][2])
	self.errandName.set_text(self.app.GetTargetName())

	#Load annotates for selected errand
	existingAnnotation = self.app.GetTextAnnotation()
	if existingAnnotation is None:
		self.annotateTextBuffer.set_text("")
	else:
		self.annotateTextBuffer.set_text(existingAnnotation)

    def ChangePage(self, widget, data=None):
	(start, end) = self.annotateTextBuffer.get_bounds()
	self.SaveTextAnnotation(self.annotateTextBuffer.get_text(start, end))

	self.errandPage.hide()
	self.findPage.hide()
	self.annotatePage.hide()	
	self.transferPage.hide()

	if data is "Errand": 
		self.treeView.set_model(self.PopulateErrandTable())
		self.errandPage.show()
	if data is "Find": self.findPage.show()
	if data is "Annotate": 
		self.annotatePage.show()
		self.AnnotatePosUpdateStatus()
		existingAnnotation = self.app.GetTextAnnotation()
		if existingAnnotation is None:
			self.annotateTextBuffer.set_text("")
		else:
			self.annotateTextBuffer.set_text(existingAnnotation)

	if data is "Transfer": 
		self.transferPage.show()

    def AnnotateSetPos(self, widget, data=None):
	self.app.SetAnnotatePositionHere()
	self.AnnotatePosUpdateStatus()

    def AnnotateClearPos(self, widget, data=None):
	self.app.ClearAnnotatePosition()
	self.AnnotatePosUpdateStatus()

    def AnnotatePosUpdateStatus(self):
	pos = self.app.GetAnnotatePosition()
	context = self.annotateStatus.get_context_id("Annotation Action")
	if pos is None:
		self.annotateStatus.push(context,"Position not set")
	else:
		self.annotateStatus.push(context,"Position:"+str(pos))

    def CalcErrandDistances(self):
	templist = []
        for wayId in self.app.waypoints.keys():
		way = self.app.waypoints[wayId]
		dist = None
		if self.app.lat is not None and self.app.lon is not None:
			dist = PythagDistLatLon((self.app.lat,self.app.lon),(way['lat'],way['lon']))

		templist.append([dist, way, wayId])
		#print way['name']

	templist.sort()

	if self.app.lat is not None and self.app.lon is not None:
		self.sortedErrands = templist #Keep nearest matches
	else:
		self.sortedErrands = templist

    def PopulateErrandTable(self):
        
	store = gtk.ListStore(float, str, str, str)
	for i in self.sortedErrands[:30]:
		dist = 0.
		if i[0] is not None:
			dist = round(i[0]/1000.,2)
		textAnnotation = self.app.GetTextAnnotation(i[2])
		isTextAnnotated = (textAnnotation is not None and len(textAnnotation) > 0)
		isAnnotated = (self.app.GetAnnotatePosition(i[2]) is not None or isTextAnnotated)
		wayName = i[1]['name']
		store.append((dist, isAnnotated, wayName, i[2]))

        return store

    def SaveTextAnnotation(self, text):
	self.app.SetTextAnnotation(text)

    def DownloadErrands(self, widget, data=None):
	self.app.DownloadErrands()
	self.RefreshErrandTable(widget, data)

    def LoadErrands(self, widget, data=None):
	self.app.LoadErrands("missing.gpx")
	self.RefreshErrandTable(widget, data)

    def UploadToInternet(self, widget, data=None):
	self.app.UploadToInternet()

    def ClearAnnotations(self, widget, data=None):
	self.app.ClearAnnotations()

    def RefreshErrandTable(self, widget, data=None):
	self.CalcErrandDistances()
	self.treeView.set_model(self.PopulateErrandTable())

    def CreateErrandTableColumns(self, treeView):
    
        rendererText = gtk.CellRendererText()
        column = gtk.TreeViewColumn("Distance", rendererText, text=0)
        column.set_sort_column_id(0)    
        treeView.append_column(column)

        rendererText = gtk.CellRendererText()
        column = gtk.TreeViewColumn("Done", rendererText, text=1)
        column.set_sort_column_id(1)
        treeView.append_column(column)
        
        rendererText = gtk.CellRendererText()
        column = gtk.TreeViewColumn("Name", rendererText, text=2)
        column.set_sort_column_id(2)
        treeView.append_column(column)

        rendererText = gtk.CellRendererText()
        column = gtk.TreeViewColumn("ID", rendererText, text=3)
        column.set_sort_column_id(3)
        treeView.append_column(column)

    def GuiRefresh(self):
	self.status.set_text("Pos "+str(self.app.lat)+","+str(self.app.lon))

	if self.app.lat is None: return
	if self.app.lon is None: return

	(tlat, tlon) = self.app.GetTargetPos()

	if tlat is not None and tlon is not None:
		dist = PythagDistLatLon((self.app.lat,self.app.lon),(tlat,tlon))
		distStr = HumanReadableDistance(dist)
		#print "Dist now",distStr

		self.targBearing = GetBearing((self.app.lat,self.app.lon),(tlat,tlon))
		if self.targBearing < 0.: self.targBearing = self.targBearing + 360.
		bearingStr = "%.0f" % self.targBearing

		self.guide.set_text(distStr+", "+bearingStr+" deg")
		#self.compass.SetBearing(self.targBearing)

		if self.app.heading is not None:
			diffHeading = DifferenceInBearing(self.app.heading, self.targBearing)
			#print "diff bearing",diffHeading
			self.compass.SetBearing(diffHeading)


    def main(self):
	self.loop.run()

def HumanReadableDistance(dist):
	if dist is None: return None
	unit = "m"
	if dist > 1000.:
		unit = "km"
		dist = dist / 1000.

	return makeSigDigs(dist,3)+" "+unit

if __name__ == "__main__":
	
	gobject.threads_init()
	dbus.mainloop.glib.DBusGMainLoop(set_as_default=True)
	obj = GeoErrandGui()
	bus = dbus.SystemBus()


	obj.main()


